C-*-FORTRAN-*-
C-----------------------------------------------------------------------------
C Invisible Higgs /  -- two analyses: IANA=1 (hadrons), 2 (leptons) 
C-----------------------------------------------------------------------------
C
C For testing purposes ONLY, activate the h->invisible BR by hand:
C
      if (.TRUE.) then
       bhn1n1 = 1.0
       write (6,*) '+------------------------------------------------+'
       write (6,*) '| INVISIBLE Higgs search / ALEPH                 |'
       write (6,*) '| WARNING! For TESTing purposes only,            |'
       write (6,*) '|          you have activated the h->invisible BR|'
       write (6,*) '|          by hand: bhn1n1 = ' , bhn1n1   
       write (6,*) '| BEWARE! This option should usually be OFF!     |'
       write (6,*) '+------------------------------------------------+'
      end if
C
C Invisible Higgs / 189 -- Two analyses: IANA=1 (hadrons), 2 (leptons)

      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
        iener = 15             ! 188.6 GeV
        j = iener - 14         ! corresponding index for invisible h functions
        do iana=1,2
          if (xtest19x) write (6,*) ainv_lumi(j)
          nchan = nchan + 1 
          if (iana.eq.1) then
            channame(nchan) = 'ALEPH 189 Invisible/Hadronic'
            nbinsint = 80         ! mass distribution
            xl = 50.
            xu = 97.8
          else if (iana.eq.2) then
            channame(nchan) = 'ALEPH 189 Invisible/Leptonic'
            nbinsint = 80         ! mass distribution
            xl = 40.0 
            xu = 100.0 
          endif

C
C Create binned shape info
C

C---- Prepare SIGNAL histogram:

          ratech = ainv_eff(j,iana,mh)*ainv_lumi(j)*bhn1n1

          if (iana.eq.1) then   ! hZ -> (inv)(qq) 
             ratech = ratech * xhz(iener) * z0toh
          elseif (iana.eq.2) then ! hZ -> (inv)(ll)
             ratech = ratech * xhz(iener)*(z0tomumu+z0toee) 
          end if
          
          if (ratech.lt.0.0) ratech=0.0
          call ascreate6(xl,xu,nbinsint,ainv_sig_dis,
     >         mh,iana,j,sighist)
          call ahistscal1(nbinsint,sighist,sig(nbins+1),ratech)
             
C---- Prepare BACKGROUND histogram:

          call ainv_bkg(j,iana,mh,bkglevel)

          call ascreate6(xl,xu,nbinsint,ainv_bkg_dis,
     >                   mh,iana,j,backhist1)
          call ahistscal1(nbinsint,backhist1,backg(nbins+1),bkglevel)

          if (XTEST19X) then
             write (6,*) 'Invisible Higgs / 189 GeV, IANA:',iana
             write (6,*) 'sig()=',(sig(nbins+j),j=1,nbinsint)
             write (6,*) 'backg()=',(backg(nbins+j),j=1,nbinsint)
          end if                ! XTEST19X
C---- Get candidates information:

          call ainv_candidates(j,iana,mh,nacand,mreco)

          if (xtest19x) write (6,*) 
     +'*** Invisible Higgs:iana,mh,rate,efficiency,btot,Ncand',
     +         iana,mh,ratech,ainv_eff(j,iana,mh),bkglevel,
     +         nacand

          do i=1,nacand           
             candmass = mreco(i)
             call abin1(candmass,xl,xu,nbinsint,ibin)
             if (ibin.gt.0.and.ibin.le.nbinsint) then
                ncand(nbins+ibin) = ncand(nbins+ibin) + 1
             endif
          enddo                 ! i

C
C systematics
C     
         ifirst(nchan) = nbins + 1
         nbins = nbins + nbinsint

         IF (IANA.EQ.1) THEN    ! hadronic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.04
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.09
         ENDIF
         IF (IANA.EQ.2) THEN    ! leptonic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.06
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.08
         ENDIF
      enddo                     ! (iana)
      endif                     ! (switch)
      
C Invisible Higgs / 192 -- Two analyses: IANA=1 (hadrons), 2 (leptons)

      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
        iener = 16             ! 192 GeV
        j = iener - 14         ! corresponding index for invisible h functions
        do iana=1,2
          if (xtest19x) write (6,*) ainv_lumi(j)
          nchan = nchan + 1 
          if (iana.eq.1) then
            channame(nchan) = 'ALEPH 192 Invisible/Hadronic'
            nbinsint = 1         ! event counting
            xl = 0.
            xu = 1.
          else if (iana.eq.2) then
            channame(nchan) = 'ALEPH 192 Invisible/Leptonic'
            nbinsint = 1        ! event counting
            xl = 0. 
            xu = 1. 
          endif

C
C Create binned shape info
C

C---- Prepare SIGNAL histogram:

          ratech = ainv_eff(j,iana,mh)*ainv_lumi(j)*bhn1n1

          if (iana.eq.1) then   ! hZ -> (inv)(qq) 
             ratech = ratech * xhz(iener) * z0toh
          elseif (iana.eq.2) then ! hZ -> (inv)(ll)
             ratech = ratech * xhz(iener)*(z0tomumu+z0toee) 
          end if
          
          if (ratech.lt.0.0) ratech=0.0
          call ascreate6(xl,xu,nbinsint,ainv_sig_dis,
     >         mh,iana,j,sighist)
          call ahistscal1(nbinsint,sighist,sig(nbins+1),ratech)
             
C---- Prepare BACKGROUND histogram:

          call ainv_bkg(j,iana,mh,bkglevel)

          call ascreate6(xl,xu,nbinsint,ainv_bkg_dis,
     >                   mh,iana,j,backhist1)
          call ahistscal1(nbinsint,backhist1,backg(nbins+1),bkglevel)

          if (XTEST19X) then
             write (6,*) 'Invisible Higgs / 192 GeV, IANA:',iana
             write (6,*) 'sig()=',(sig(nbins+j),j=1,nbinsint)
             write (6,*) 'backg()=',(backg(nbins+j),j=1,nbinsint)
          end if                ! XTEST19X
C---- Get candidates information:

          call ainv_candidates(j,iana,mh,nacand,mreco)

          if (xtest19x) write (6,*) 
     +'*** Invisible Higgs:iana,mh,rate,efficiency,btot,Ncand',
     +         iana,mh,ratech,ainv_eff(j,iana,mh),bkglevel,
     +         nacand

          do i=1,nacand
             ncand(nbins+1) = ncand(nbins+1) + 1
          enddo                 ! i

C
C systematics
C     
         ifirst(nchan) = nbins + 1
         nbins = nbins + nbinsint

         IF (IANA.EQ.1) THEN    ! hadronic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.05
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.09
         ENDIF
         IF (IANA.EQ.2) THEN    ! leptonic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.06
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.08 
         ENDIF
      enddo                     ! (iana)
      endif                     ! (switch)
      
C Invisible Higgs / 196 -- Two analyses: IANA=1 (hadrons), 2 (leptons)

      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
        iener = 17             ! 196 GeV
        j = iener - 14         ! corresponding index for invisible h functions
        do iana=1,2
          if (xtest19x) write (6,*) ainv_lumi(j)
          nchan = nchan + 1 
          if (iana.eq.1) then
            channame(nchan) = 'ALEPH 196 Invisible/Hadronic'
            nbinsint = 1         ! event counting
            xl = 0.
            xu = 1.
          else if (iana.eq.2) then
            channame(nchan) = 'ALEPH 196 Invisible/Leptonic'
            nbinsint = 1         ! event counting
            xl = 0.
            xu = 1.
          endif

C
C Create binned shape info
C

C---- Prepare SIGNAL histogram:

          ratech = ainv_eff(j,iana,mh)*ainv_lumi(j)*bhn1n1

          if (iana.eq.1) then   ! hZ -> (inv)(qq) 
             ratech = ratech * xhz(iener) * z0toh
          elseif (iana.eq.2) then ! hZ -> (inv)(ll)
             ratech = ratech * xhz(iener)*(z0tomumu+z0toee) 
          end if
          
          if (ratech.lt.0.0) ratech=0.0
          call ascreate6(xl,xu,nbinsint,ainv_sig_dis,
     >         mh,iana,j,sighist)
          call ahistscal1(nbinsint,sighist,sig(nbins+1),ratech)
             
C---- Prepare BACKGROUND histogram:

          call ainv_bkg(j,iana,mh,bkglevel)

          call ascreate6(xl,xu,nbinsint,ainv_bkg_dis,
     >                   mh,iana,j,backhist1)
          call ahistscal1(nbinsint,backhist1,backg(nbins+1),bkglevel)

          if (XTEST19X) then
             write (6,*) 'Invisible Higgs / 196 GeV, IANA:',iana
             write (6,*) 'sig()=',(sig(nbins+j),j=1,nbinsint)
             write (6,*) 'backg()=',(backg(nbins+j),j=1,nbinsint)
          end if                ! XTEST19X
C---- Get candidates information:

          call ainv_candidates(j,iana,mh,nacand,mreco)

          if (xtest19x) write (6,*) 
     +'*** Invisible Higgs:iana,mh,rate,efficiency,btot,Ncand',
     +         iana,mh,ratech,ainv_eff(j,iana,mh),bkglevel,
     +         nacand

          do i=1,nacand
             ncand(nbins+1) = ncand(nbins+1) + 1
          enddo                 ! i

C
C systematics
C     
         ifirst(nchan) = nbins + 1
         nbins = nbins + nbinsint

         IF (IANA.EQ.1) THEN    ! hadronic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.05
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.09
         ENDIF
         IF (IANA.EQ.2) THEN    ! leptonic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.06
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.08 
         ENDIF
      enddo                     ! (iana)
      endif                     ! (switch)
      
C Invisible Higgs / 200 -- Two analyses: IANA=1 (hadrons), 2 (leptons)

      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
        iener = 18             ! 200 GeV
        j = iener - 14         ! corresponding index for invisible h functions
        do iana=1,2
          if (xtest19x) write (6,*) ainv_lumi(j)
          nchan = nchan + 1 
          if (iana.eq.1) then
            channame(nchan) = 'ALEPH 200 Invisible/Hadronic'
            nbinsint = 1         ! event counting
            xl = 0.
            xu = 1.
          else if (iana.eq.2) then
            channame(nchan) = 'ALEPH 200 Invisible/Leptonic'
            nbinsint = 1        ! event counting 
            xl = 0.
            xu = 1.
          endif

C
C Create binned shape info
C

C---- Prepare SIGNAL histogram:

          ratech = ainv_eff(j,iana,mh)*ainv_lumi(j)*bhn1n1

          if (iana.eq.1) then   ! hZ -> (inv)(qq) 
             ratech = ratech * xhz(iener) * z0toh
          elseif (iana.eq.2) then ! hZ -> (inv)(ll)
             ratech = ratech * xhz(iener)*(z0tomumu+z0toee) 
          end if
          
          if (ratech.lt.0.0) ratech=0.0
          call ascreate6(xl,xu,nbinsint,ainv_sig_dis,
     >         mh,iana,j,sighist)
          call ahistscal1(nbinsint,sighist,sig(nbins+1),ratech)
             
C---- Prepare BACKGROUND histogram:

          call ainv_bkg(j,iana,mh,bkglevel)

          call ascreate6(xl,xu,nbinsint,ainv_bkg_dis,
     >                   mh,iana,j,backhist1)
          call ahistscal1(nbinsint,backhist1,backg(nbins+1),bkglevel)

          if (XTEST19X) then
             write (6,*) 'Invisible Higgs / 189 GeV, IANA:',iana
             write (6,*) 'sig()=',(sig(nbins+j),j=1,nbinsint)
             write (6,*) 'backg()=',(backg(nbins+j),j=1,nbinsint)
          end if                ! XTEST19X
C---- Get candidates information:

          call ainv_candidates(j,iana,mh,nacand,mreco)

          if (xtest19x) write (6,*) 
     +'*** Invisible Higgs:iana,mh,rate,efficiency,btot,Ncand',
     +         iana,mh,ratech,ainv_eff(j,iana,mh),bkglevel,
     +         nacand

          do i=1,nacand
             ncand(nbins+1) = ncand(nbins+1) + 1
          enddo                 ! i

C
C systematics
C     
         ifirst(nchan) = nbins + 1
         nbins = nbins + nbinsint

         IF (IANA.EQ.1) THEN    ! hadronic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.05
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.09
         ENDIF
         IF (IANA.EQ.2) THEN    ! leptonic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.06
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.08
         ENDIF
      enddo                     ! (iana)
      endif                     ! (switch)
      
C Invisible Higgs / 202 -- Two analyses: IANA=1 (hadrons), 2 (leptons)

      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
        iener = 19             ! 202 GeV
        j = iener - 14         ! corresponding index for invisible h functions
        do iana=1,2
          if (xtest19x) write (6,*) ainv_lumi(j)
          nchan = nchan + 1 
          if (iana.eq.1) then
            channame(nchan) = 'ALEPH 202 Invisible/Hadronic'
            nbinsint = 1         ! event counting
            xl = 0.
            xu = 1.
          else if (iana.eq.2) then
            channame(nchan) = 'ALEPH 202 Invisible/Leptonic'
            nbinsint = 1        ! event counting
            xl = 0. 
            xu = 1. 
          endif

C
C Create binned shape info
C

C---- Prepare SIGNAL histogram:

          ratech = ainv_eff(j,iana,mh)*ainv_lumi(j)*bhn1n1

          if (iana.eq.1) then   ! hZ -> (inv)(qq) 
             ratech = ratech * xhz(iener) * z0toh
          elseif (iana.eq.2) then ! hZ -> (inv)(ll)
             ratech = ratech * xhz(iener)*(z0tomumu+z0toee) 
          end if
          
          if (ratech.lt.0.0) ratech=0.0
          call ascreate6(xl,xu,nbinsint,ainv_sig_dis,
     >         mh,iana,j,sighist)
          call ahistscal1(nbinsint,sighist,sig(nbins+1),ratech)
             
C---- Prepare BACKGROUND histogram:

          call ainv_bkg(j,iana,mh,bkglevel)

          call ascreate6(xl,xu,nbinsint,ainv_bkg_dis,
     >                   mh,iana,j,backhist1)
          call ahistscal1(nbinsint,backhist1,backg(nbins+1),bkglevel)

          if (XTEST19X) then
             write (6,*) 'Invisible Higgs / 202 GeV, IANA:',iana
             write (6,*) 'sig()=',(sig(nbins+j),j=1,nbinsint)
             write (6,*) 'backg()=',(backg(nbins+j),j=1,nbinsint)
          end if                ! XTEST19X
C---- Get candidates information:

          call ainv_candidates(j,iana,mh,nacand,mreco)

          if (xtest19x) write (6,*) 
     +'*** Invisible Higgs:iana,mh,rate,efficiency,btot,Ncand',
     +         iana,mh,ratech,ainv_eff(j,iana,mh),bkglevel,
     +         nacand

          do i=1,nacand
             ncand(nbins+1) = ncand(nbins+1) + 1
          enddo                 ! i

C
C systematics
C     
         ifirst(nchan) = nbins + 1
         nbins = nbins + nbinsint

         IF (IANA.EQ.1) THEN    ! hadronic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.05
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.09
         ENDIF
         IF (IANA.EQ.2) THEN    ! leptonic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.06
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.08
         ENDIF
      enddo                     ! (iana)
      endif                     ! (switch)

C Invisible Higgs / 205 -- Two analyses: IANA=1 (hadrons), 2 (leptons)

      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
         j = 6                  ! corresponding index for invisible h functions
        do iana=1,2
c          if (xtest19x) write (6,*) ainv_lumi(j)
          nchan = nchan + 1 
          if (iana.eq.1) then
            channame(nchan) = 'ALEPH 205 Invisible/Hadronic'
            nbinsint = 1         ! event counting
            xl = 0.
            xu = 1.
          else if (iana.eq.2) then
            channame(nchan) = 'ALEPH 205 Invisible/Leptonic'
            nbinsint = 40     
            xl = 45. 
            xu = 125. 
          endif

C
C Create binned shape info
C

C---- Prepare SIGNAL histogram:
c
          lumi22 = ainv_lumi_y2k(1)
          lumi23 = ainv_lumi_y2k(2)
          lumi24 = ainv_lumi_y2k(3)
          lumi25 = ainv_lumi_y2k(4)
          lumi26 = ainv_lumi_y2k(5)
          lumi27 = ainv_lumi_y2k(6)
          lumi28 = ainv_lumi_y2k(7)
          ecm22  = ainv_ecm_y2k(1)
          ecm23  = ainv_ecm_y2k(2)
          ecm24  = ainv_ecm_y2k(3)
          ecm25  = ainv_ecm_y2k(4)
          ecm26  = ainv_ecm_y2k(5)
          ecm27  = ainv_ecm_y2k(6)
          ecm28  = ainv_ecm_y2k(7)
c
          if (iana.eq.1) then   ! hZ -> (inv)(qq)
             ratech = 0.98d0*(
     .             dble(ainv_effy2k(xdouble,1)*lumi22)
     .           * ainv_hz_y2k(ecm22,xdouble,0) 
     .           + dble((ainv_effy2k(xdouble,1) 
     .                 + ainv_effy2k(xdouble,2))/2.*lumi23)
     .           * ainv_hz_y2k(ecm23,xdouble,0)
     .           + dble(ainv_effy2k(xdouble,2)*lumi24)
     .           * ainv_hz_y2k(ecm24,xdouble,0)
     .           + dble(ainv_effy2k(xdouble,3)*lumi25)
     .           * ainv_hz_y2k(ecm25,xdouble,0))
     .            *bhn1n1*z0toh
          elseif (iana.eq.2) then ! hZ -> (inv)(ll)
             ratech =  
     .          (ainv_hz_y2k(ecm23,xdouble,0)
     .         * dble(lumi23*effy2klep_ainv(sngl(xdouble),203.))
     .         + ainv_hz_y2k(ecm24,xdouble,0)
     .         * dble(lumi24*effy2klep_ainv(sngl(xdouble),204.))
     .         + ainv_hz_y2k(ecm25,xdouble,0)
     .         * dble(lumi25*effy2klep_ainv(sngl(xdouble),205.))
     .         + ainv_hz_y2k(ecm26,xdouble,0)
     .         * dble(lumi26*effy2klep_ainv(sngl(xdouble),206.))
     .         + ainv_hz_y2k(ecm27,xdouble,0)
     .         * dble(lumi27*effy2klep_ainv(sngl(xdouble),207.))
     .         + ainv_hz_y2k(ecm28,xdouble,0)
     .         * dble(lumi28*effy2klep_ainv(sngl(xdouble),208.)))
     .         * bhn1n1*(z0tomumu+z0toee)
          end if
          
          if (ratech.lt.0.0) ratech=0.0
          call ascreate6(xl,xu,nbinsint,ainv_sig_dis,
     >         mh,iana,j,sighist)
          call ahistscal1(nbinsint,sighist,sig(nbins+1),ratech)
             
C---- Prepare BACKGROUND histogram:

          call ainv_bkg(j,iana,mh,bkglevel)

          call ascreate6(xl,xu,nbinsint,ainv_bkg_dis,
     >                   mh,iana,j,backhist1)
          call ahistscal1(nbinsint,backhist1,backg(nbins+1),bkglevel)

          if (XTEST19X) then
             write (6,*) 'Invisible Higgs / 205 GeV, IANA:',iana
             write (6,*) 'sig()=',(sig(nbins+j),j=1,nbinsint)
             write (6,*) 'backg()=',(backg(nbins+j),j=1,nbinsint)
          end if                ! XTEST19X
C---- Get candidates information:

          call ainv_candidates(j,iana,mh,nacand,mreco)

          if (xtest19x) write (6,*) 
     +'*** Invisible Higgs:iana,mh,rate,efficiency,btot,Ncand',
     +         iana,mh,ratech,ainv_eff(j,iana,mh),bkglevel,
     +         nacand

          do i=1,nacand
           
C     NB for iana = 1 (hadronic) 
C     ---> put all candidates in the same bin

             IF (IANA.EQ.1) THEN
                ncand(nbins+1) = ncand(nbins+1) + 1
             ELSE
                candmass = mreco(i)
                call abin1(candmass,xl,xu,nbinsint,ibin)
                if (ibin.gt.0.and.ibin.le.nbinsint) then
                   ncand(nbins+ibin) = ncand(nbins+ibin) + 1
                endif
             END IF             ! IANA
          enddo                 ! i

C
C systematics
C     
         ifirst(nchan) = nbins + 1
         nbins = nbins + nbinsint

         IF (IANA.EQ.1) THEN    ! hadronic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.05
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.09
         ENDIF
         IF (IANA.EQ.2) THEN    ! leptonic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.06
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.08
         ENDIF
      enddo                     ! (iana)
      endif                     ! (switch)

C Invisible Higgs / 207 -- Two analyses: IANA=1 (hadrons), 2 (leptons)

      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
         j = 7                  ! corresponding index for invisible h functions
        do iana=1,2
          if (xtest19x) write (6,*) ainv_lumi(j)
          nchan = nchan + 1 
          if (iana.eq.1) then
            channame(nchan) = 'ALEPH 207 Invisible/Hadronic'
            nbinsint = 1         ! event counting
            xl = 0.
            xu = 1.
          else if (iana.eq.2) then
            channame(nchan) = 'ALEPH 207 Invisible/Leptonic'
            nbinsint = 1        ! event counting
            xl = 0. 
            xu = 1. 
          endif

C
C Create binned shape info
C

C---- Prepare SIGNAL histogram:

          if (iana.eq.1) then   ! hZ -> (inv)(qq)
             ratech = 0.98d0*
     .            (dble(ainv_effy2k(xdouble,4)*lumi26)
     .           * ainv_hz_y2k(ecm26,xdouble,0)  
     .           + dble(ainv_effy2k(xdouble,5)*lumi27)
     .           * ainv_hz_y2k(ecm27,xdouble,0)
     .           + dble(ainv_effy2k(xdouble,5)*lumi28)
     .           * ainv_hz_y2k(ecm28,xdouble,0))
     .            *bhn1n1*z0toh
             print *, '207',ratech
          elseif (iana.eq.2) then ! hZ -> (inv)(ll)
             ratech = 0d0
          end if
          
          if (ratech.lt.0.0) ratech=0.0
          call ascreate6(xl,xu,nbinsint,ainv_sig_dis,
     >         mh,iana,j,sighist)
          call ahistscal1(nbinsint,sighist,sig(nbins+1),ratech)
             
C---- Prepare BACKGROUND histogram:

          call ainv_bkg(j,iana,mh,bkglevel)

          call ascreate6(xl,xu,nbinsint,ainv_bkg_dis,
     >                   mh,iana,j,backhist1)
          call ahistscal1(nbinsint,backhist1,backg(nbins+1),bkglevel)

          if (XTEST19X) then
             write (6,*) 'Invisible Higgs / 207 GeV, IANA:',iana
             write (6,*) 'sig()=',(sig(nbins+j),j=1,nbinsint)
             write (6,*) 'backg()=',(backg(nbins+j),j=1,nbinsint)
          end if                ! XTEST19X
C---- Get candidates information:

          call ainv_candidates(j,iana,mh,nacand,mreco)

          if (xtest19x) write (6,*) 
     +'*** Invisible Higgs:iana,mh,rate,efficiency,btot,Ncand',
     +         iana,mh,ratech,ainv_eff(j,iana,mh),bkglevel,
     +         nacand

          do i=1,nacand           
             ncand(nbins+1) = ncand(nbins+1) + 1
          enddo                 ! i

C
C systematics
C     
         ifirst(nchan) = nbins + 1
         nbins = nbins + nbinsint

         IF (IANA.EQ.1) THEN    ! hadronic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.05
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.09
         ENDIF
         IF (IANA.EQ.2) THEN    ! leptonic
            CORSIG(NCHAN) = 0.0
            UNCSIG(NCHAN) = 0.06
            CORBKG(NCHAN) = 0.0
            UNCBKG(NCHAN) = 0.08
         ENDIF
      enddo                     ! (iana)
      endif                     ! (switch)
      
      





